;;;                  MASSACHUSETTS INSTITUTE OF TECHNOLOGY
;;;        Department of Electrical Engineering and Computer Science
;;;        6.001---Structure and Interpretation of Computer Programs
;;;                           Fall Semester, 1997
;;;                              Problem Set 7
;;;
;;;                         Code file WORLD.SCM

;;;========================================================================
;;; You can extend this file to make more stuff part of your world.
;;;========================================================================

;;;========================================================================
;;; *CAVEAT* To keep your world consistent, whenever you change a procedure
;;; or redefine a person/place/etc., you should reload this entire file
;;; into Scheme.  This prevents you from having old folks running around
;;; who have not evolved to adhere to your modifications.  To make this
;;; work out well, you should create little scripts at the end of this file
;;; to make the game evolve as you work through it.
;;; [See the bottom of this file for an example.

;; Here we define the places in our world...
;;------------------------------------------

(define EGG-Atrium         (new place-class 'EGG-Atrium))
(define Whitehead          (new place-class 'Whitehead))
(define dungeon            (new place-class 'dungeon))
(define Building-36        (new place-class 'Building-36))
(define computer-lab       (new place-class 'computer-lab))
(define Tech-Square        (new place-class 'Tech-Square))
(define lounge             (new place-class 'Lounge))
(define albert-office      (new place-class 'albert-office))
(define rod-office         (new place-class 'rod-office))
(define ta-office          (new place-class 'ta-office))
(define dormitory          (new place-class 'dormitory))
(define rover-lab          (new place-class 'rover-lab))
(define mars-landing-site  (new place-class 'mars-landing-site))
; The point of no return
(define heaven             (new place-class 'heaven))


;;;EXECUTE AFTER COMPLETING Exercise 6:
;(define transporter-room-1 
;  (new transporter-class 'transporter-room-1 mars-landing-site))
;(define transporter-room-2 
;  (new transporter-class 'transporter-room-2 lounge))

;; One-way paths connect individual places in the world.
;;------------------------------------------------------

(define (can-go from direction to)
  (ask from 'ADD-NEIGHBOR direction to))

(define (can-go-both-ways from direction reverse-direction to)
  (can-go from direction to)
  (can-go to reverse-direction from))

(can-go-both-ways Building-36       'up     'down  computer-lab)
(can-go-both-ways Building-36       'north  'south Tech-Square)
(can-go-both-ways Building-36       'west   'east  EGG-Atrium)
(can-go-both-ways Tech-Square       'east   'west  Whitehead)
(can-go-both-ways Tech-Square       'up     'down  lounge)
(can-go-both-ways lounge            'door-1 'west  albert-office)
(can-go-both-ways lounge            'door-2 'west  rod-office)
(can-go-both-ways lounge            'door-3 'west  ta-office)
(can-go-both-ways dormitory         'west   'east  Building-36)
(can-go-both-ways computer-lab      'up     'down  rover-lab)

;;;EXECUTE AFTER COMPLETING Exercise 6:
;(can-go-both-ways rover-lab         'east   'west  transporter-room-1)
;(can-go-both-ways mars-landing-site 'north  'south transporter-room-2)

(can-go dungeon      'up    EGG-Atrium)

;; The system clock (so that we can animate people).

(define system-clock (new clock-class 'the-system-clock))
(define (animate object)
  (ask system-clock 'add-to-list object)
  object)
(define (run-clock n) (ask system-clock 'run n))

;; The important critters in our world...
;;---------------------------------------

(define albert (animate (new person-class 'albert albert-office 2)))
(define rod    (animate (new person-class 'rod    rod-office 3)))

(define grendel (animate (new troll-class 'grendel dungeon 4)))

